//To give names to each node of the tree
const Data = {
  "name": "Felidae",
  "value": 9,
  "type": "brown",
  "level": "red",
  "children": [
    {  
      "name": "Pantherinae",
      "value": 9,
      "type": "lightgreen",
      "level": "green",
      "children": [
        //To Name the sub unit of the Pantherinae
        {
          "name": "Panthera",
          "value": 9,
          "type": "pink",
          "level": "orange",
          "children":[
            //To Name the sub units of Panthera
            {
              "name": "Lion",
              "value": 9,
               "type": "aquamarine",
               "level": "purple",
            },
            {
              "name": "Tiger",
              "value": 9,
               "type": "aquamarine",
               "level": "purple",
            },
            {
              "name": "Jaguar",
              "value": 9,
               "type": "aquamarine",
               "level": "purple",
            },
            {
              "name": "Leopard",
              "value": 9,
               "type": "aquamarine",
               "level": "purple",
            },
            {
              "name": "Snow Leopard",
              "value": 9,
               "type": "aquamarine",
               "level": "purple",
            }
      ]
  },
        {
          // To Name another sub unit of Pantherinae
          "name": "Neofelis",
          "value": 9,
          "type": "pink",
          "level": "orange",
           "children": [
           {
             //To name the sub units of Neofelis
          "name": "Clouded Leopard",
          "value": 9,
          "type": "aquamarine",
          "level": "purple",
          },
         {
          "name": "Sunda Clouded Leopard",
          "value": 9,
          "type": "aquamarine",
          "level": "purple"
        }
      ]
    },
        ]
    },
    {
      //To Name the second sub unit of Felidae
      "name": "Felinae",
      "value": 9,
      "type": "lightgreen",
      "level": "green",
      "children": [
         {
           
      //Naming the first sub unit of Felinae
          "name": "Acinonyx",
          "value": 9,
          "type": "pink",
          "level": "orange",
          "children":[
            {
              "name": "Cheetah",
              "value": 9,
               "type": "aquamarine",
               "level": "purple",
            }, 
      ]
    },
         {
           //To Name the second sub unit of Felinae
          "name": "Puma",
          "value": 9,
          "type": "pink",
          "level": "orange",
           "children": [
           {
          "name": "Cougar",
          "value": 9,
          "type": "aquamarine",
          "level": "purple",
          }
      ]
    },
        {
          // To Name the third sub unit of Felinae
          "name": "Wild cat genius",
          "value": 9,
          "type": "pink",
          "level": "orange",
           "children": [
           {
             //To name the children of wild cat genius
          "name": "Pampas Cat",
          "value": 9,
          "type": "aquamarine",
          "level": "purple",
          },
         {
          "name": "Andean Cat",
          "value": 9,
          "type": "aquamarine",
          "level": "purple"
        },
          {
          "name": "Rusty Spotted Cat",
          "value": 9,
          "type": "aquamarine",
          "level": "purple"
        },
      ]
    },
  ]
    },
     
    ]
};

// To define width,height and margin of the tree
const margin = {top: 10, right: 250, bottom:200, left: 200},
      width  = 850 - margin.left - margin.right,
      height = 650 - margin.top - margin.bottom;

const tree = d3.tree().size([height, width]);

//To Assign heirarchical structure to classify the data
let nodes = d3.hierarchy(Data, node => node.children);

//To Provide data connection for nodes to their respective position in the tree
nodes = tree(nodes);

//To Add an svg element
const svg = d3.select("body").append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom),
      g = svg.append("g")//appends group
        .attr("transform",
            "translate(" + margin.left + "," + margin.top + ")");

//To Define links between nodes
const link = g.selectAll(".link")
    .data( nodes.descendants().slice(1))
  .enter().append("path")
    .attr("class", "link")
    .style("stroke", d => d.data.level)
    .attr("d", d => {
       return "M" + d.y + "," + d.x
         + "C" + (d.y + d.parent.y) / 2 + "," + d.x
         + " " + (d.y + d.parent.y) / 2 + "," + d.parent.x
         + " " + d.parent.y + "," + d.parent.x;
       });

//To declare a group for each node present in the tree
const node = g.selectAll(".node")
    .data(nodes.descendants())
    .enter().append("g")
    .attr("class", d => "node" + (d.children ? " node--internal" : " node--leaf"))
    .attr("transform", d => "translate(" + d.y + "," + d.x + ")");

//To Define shape of the node
node.append("circle")
  .attr("r", d => d.data.value)
  .style("stroke", d => d.data.type)
  .style("fill", d => d.data.level);
  
//To add a new node to the list
node.append("text")
  .attr("dy", ".60em")
  .attr("x", d => d.children ? (d.data.value + 5) * -1 : d.data.value + 5)
  .attr("y", d => d.children && d.depth !== 0 ? -(d.data.value + 5) : d)
  .style("text-anchor", d => d.children ? "end" : "start")
  .text(d => d.data.name);